VERSION 5.00
Begin VB.Form frmMain 
   BackColor       =   &H80000004&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Controllo ortografico"
   ClientHeight    =   2745
   ClientLeft      =   6690
   ClientTop       =   3525
   ClientWidth     =   4125
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2745
   ScaleWidth      =   4125
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton Command2 
      Caption         =   "Thesaurus"
      Height          =   450
      Left            =   2085
      TabIndex        =   2
      Top             =   2115
      Width           =   1905
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Controllo ortografico"
      Height          =   450
      Left            =   90
      TabIndex        =   1
      Top             =   2115
      Width           =   1905
   End
   Begin VB.TextBox txtText 
      BackColor       =   &H00C0FFFF&
      ForeColor       =   &H00000000&
      Height          =   1785
      Left            =   75
      MultiLine       =   -1  'True
      TabIndex        =   0
      Text            =   "frmMain.frx":000C
      ToolTipText     =   "Enter your text here"
      Top             =   135
      Width           =   3915
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const HTCAPTION = 2
Const WM_NCLBUTTONDOWN = &HA1

Private Declare Function ReleaseCapture Lib "user32" () As Long

Private Declare Function SendMessage Lib "user32" _
    Alias "SendMessageA" (ByVal hwnd As Long, _
    ByVal wMsg As Long, ByVal wParam As Long, _
    lParam As Any) As Long
Private Sub Form_Unload(Cancel As Integer)
    On Error Resume Next
    Set frmMain = Nothing
End Sub
Private Sub Command1_Click()
Dim strText        As String
Dim lngSuggWord    As Long
Dim lngStart       As Long
Dim lngPos         As Long
Dim blnDone        As Boolean
Dim objWord        As Word.Application
Dim objDoc         As Document
Dim colSuggestions As SpellingSuggestions
Dim colSpellErrors As ProofreadingErrors
    '
    '---------------------------------------------
    ' Inizializza la verifica ortografica del testo
    '---------------------------------------------
    '
    On Error GoTo ErrorHandler
    '
    ' Avvia Word in modalit nascosta.
    '
    Set objWord = CreateObject("word.application")
    objWord.Visible = False
    objWord.WindowState = wdWindowStateMinimize
    '
    ' Crea un nuovo documento di Word.
    '
    Set objDoc = objWord.Documents.Add
    '
    ' Crea un ciclo con le parole del testo.
    '
    blnDone = False
    lngStart = 1
    lngPos = 0
    
    Do While Not blnDone
        '
        ' Suddivide il testo in parole.
        '
        lngStart = lngPos + 1
        lngPos = InStr(lngStart, txtText.Text, " ")
        If lngPos = 0 Then
            lngPos = Len(txtText.Text) + 1
            blnDone = True
        End If
        '
        ' Seleziona la parola.
        '
        txtText.SelStart = lngStart - 1
        txtText.SelLength = lngPos - lngStart

        If txtText.SelText <> "" Then
            '
            ' Setta il documento di Word col
            ' testo selezionato e richiama
            ' il correttore ortografico.
            '
            objDoc.Range.Delete
            objDoc.Range = txtText.SelText
            Set colSpellErrors = objDoc.SpellingErrors
            '
            ' Se ci sono errori, richiama i suggerimenti.
            '
            If colSpellErrors.Count > 0 Then
                With frmDizio
                    .txtBadWord.Text = colSpellErrors.Item(1)
                
                    Set colSuggestions = objWord.GetSpellingSuggestions(colSpellErrors.Item(1))
                    .lstSuggestions.Clear
                
                    For lngSuggWord = 1 To colSuggestions.Count
                        .lstSuggestions.AddItem colSuggestions.Item(lngSuggWord)
                    Next
                    '
                    ' Visualizza la finestra di dialogo dei suggerimenti.
                    '
                    .Show vbModal
                    '
                    ' Cambia il testo richiamato con
                    ' la nuova parola corretta.
                    '
                    If .ReplacementWord <> "" Then
                        txtText.SelText = .ReplacementWord
                        lngPos = lngPos + .LengthDifference
                    End If
                End With
            End If
        End If
    Loop
    txtText.SelStart = 0
    txtText.SelLength = 0
    GoTo NormalExit
ErrorHandler:
    MsgBox "Si  verificato il seguente errore durante la correzione ortografica:" & vbCrLf & Err.Description
NormalExit:
    '
    ' Chiude Word ed elimina il documento.
    '
    objDoc.Close savechanges:=wdDoNotSaveChanges
    objWord.Quit savechanges:=wdDoNotSaveChanges
    Set objWord = Nothing
    Set objDoc = Nothing
End Sub
Private Sub Command2_Click()
Dim objWord As Word.Application
Dim objDoc  As Document
Dim strText As String
    '
    '---------------------------------------------
    ' Cerca un sinonimo della parola selezionata.
    '---------------------------------------------
    '
    On Error GoTo NormalExit
    '
    ' Legge il testo selezionato.
    '
    If txtText.SelText = "" Then Exit Sub
    '
    ' Avvia Word in modalit nascosta.
    '
    Set objWord = CreateObject("word.application")
    objWord.Visible = False
    objWord.WindowState = wdWindowStateMinimize
    '
    ' Crea un nuovo documento di Word.
    '
    Set objDoc = objWord.Documents.Add
    '
    ' Setta il documento di Word col
    ' testo selezionato e richiama
    ' il thesaurus.
    '
    objDoc.Range = txtText.SelText
    objDoc.Range.CheckSynonyms
    '
    ' Sostituisce il testo
    ' col sinonimo selezionato.
    '
    strText = objDoc.Range
    strText = Left$(strText, Len(strText) - 1)
    txtText.SelText = strText
    '
    ' Chiude Word ed elimina il documento.
    '
NormalExit:
    On Error Resume Next
    objDoc.Close savechanges:=wdDoNotSaveChanges
    objWord.Quit savechanges:=wdDoNotSaveChanges
    Set objWord = Nothing
    Set objDoc = Nothing
End Sub


